import os
import sys

os.environ["MAYA_LOCATION"] = "C:\Program Files\Autodesk\Maya2009"
os.environ["PYTHONHOME"]    = "C:\Program Files\Autodesk\Maya2009\Python"

sys.path.append("C:\Program Files\Autodesk\Maya2009\\bin\python25.zip")
sys.path.append("C:\Program Files\Autodesk\Maya2009\Python\DLLs")
sys.path.append("C:\Program Files\Autodesk\Maya2009\Python\lib")
sys.path.append("C:\Program Files\Autodesk\Maya2009\Python\lib\plat-win")
sys.path.append("C:\Program Files\Autodesk\Maya2009\Python\lib\lib-tk")
sys.path.append("C:\Program Files\Autodesk\Maya2009\\bin")
sys.path.append("C:\Program Files\Autodesk\Maya2009\Python")
sys.path.append("C:\Program Files\Autodesk\Maya2009\Python\lib\site-packages")

os.environ["PATH"] = "C:\\Program Files\\Autodesk\\Maya2009\\bin;" + os.environ["PATH"]




def Export(mayaScene, outputDir, rpName, unitName):

    import maya.standalone
    maya.standalone.initialize('python')

    import maya.cmds as cmds
    import maya.mel as mel



    try:
        cmds.file(f = True, new = True)
        cmds.file(mayaScene, o = True, f = True, iv = True)
    except:
        print "COULDN'T OPEN THE FILE"





    try:
        #mel.eval('string $maya_loc = `getenv MAYA_LOCATION`');
        mel.eval('catch(loadPlugin (`getenv MAYA_LOCATION` + "/bin/plug-ins/GrinMayaTools.mll"));')
        #mel.eval('catch(`loadPlugin "C:/Program Files/Autodesk/Maya2009/bin/plug-ins/GrinMayaTools.mll"`);')
    except:
        print "COULN*T LOAD THE PLUGIN"




    try:
        melSelection = 'select -r ' + rpName + ';'

        fileName = outputDir + '/' + unitName + '.model'
        melExport = 'grinExportScene -email "Yasin.Uludag@Supersledge.com" -animations -meshes -root ' + '"' + rpName + '"' + ' "' +  fileName + '";'

        mel.eval(melSelection)
        mel.eval(melExport)
        #mel.eval('grinExportScene -email "Yasin.Uludag@Supersledge.com" -meshes -root "rp_baggage_truck" "C:/Users/yasulu/Desktop/PyQT/baggage_truck.model" -animations;')
    except:
        melSelection = 'select -r ' + rpName + ';'
        fileName = outputDir + '/' + rpName.replace("rp_", "") + '.model'
        melExport = 'grinExportScene -email "Yasin.Uludag@Supersledge.com" -animations -meshes -root ' + '"' + rpName + '"' + ' "' +  fileName + '";'

        print "===================================================================================================="
        print "SELECTION COMMAND:", melSelection
        print "===================================================================================================="
        print "EXPORT COMMAND:", melExport
        print "===================================================================================================="
        print "COULDN*T EXPORT"
        print "===================================================================================================="






if __name__ == "__main__":

    if len(sys.argv) < 4:
        print "Error: no file to export!"
        raise SystemExit

    for i, arg in enumerate(sys.argv):
        print "ARGUMENT " + str(i) + ": " + str(arg)

    mayaScene = sys.argv[1]


    if not os.path.exists(mayaScene):
        print "Error: %s doesnot exist." % mayaScene
        raise SystemExit

    outputDir = sys.argv[2]
    if not os.path.exists(outputDir):
        os.makedirs(outputDir)

    rpName   = sys.argv[3]
    unitName = sys.argv[4]

    print "MAYA SCENE :", mayaScene
    print "OUTPUT PATH:", outputDir
    print "RP NAME    :", rpName
    print "UNIT NAME  :", unitName

    #Export("D:/projects/stonecold_source/trunk/assets/units/world/architecture/apartment/back_alley/alley_01.mb", "D:/projects/stonecold/trunk/assets/units/world/architecture/apartment/back_alley")
    Export(mayaScene, outputDir, rpName, unitName)

